""" Extract all the aliases of component indices """

from ufl.algorithms import MultiFunction


class _ComponentIndexMapping(MultiFunction):
    call = MultiFunction.__call__

    def __call__(self, o):
        self.shape = 0
        self.component_index_dict = {}
        self.tree_path = None
        self.call(o)

        return self.component_index_dict

    def expr(self, o):
        for op in o.ufl_operands:
            self.call(op)

    def function_view(self, o):
        self.tree_path = o.ufl_operands[1]
        self.call(o.ufl_operands[0])
        self.tree_path = None

    def argument(self, o):
        if self.tree_path:
            from ufl.functionview import select_subelement
            subelement = select_subelement(o.ufl_element(), self.tree_path)
            self.shape = len(subelement.value_shape())

    def indexed(self, o):
        self.call(o.ufl_operands[0])
        for i in range(self.shape):
            from dune.perftool.pdelab.geometry import component_iname
            self.component_index_dict[o.ufl_operands[1][i]] = component_iname(context='arg', count=i)
        self.shape = 0


def component_index_mapping(expr):
    return _ComponentIndexMapping()(expr)
